package model

import (
	"time"

	"go.mongodb.org/mongo-driver/bson/primitive"
)

type ArtworkColor struct {
	RGBA   []float32 `bson:"rgba,omitempty" json:"rgba"`
	Name   string    `bson:"name,omitempty" json:"name"`
	MatKey string    `bson:"matkey,omitempty" json:"matkey"`
}

type FinishArtwork struct {
	Id            primitive.ObjectID `bson:"_id,omitempty" json:"_id"`
	Name          string             `bson:"name,omitempty" json:"name"`
	Thumb         string             `bson:"thumb,omitempty" json:"thumb"`
	Desc          string             `bson:"desc,omitempty" json:"desc"`
	FinishId      string             `bson:"finishId,omitempty" json:"finishId"`
	MeshId        string             `bson:"meshId,omitempty" json:"meshId"`
	MatKey        string             `bson:"matkey,omitempty" json:"matkey"`
	IsCanCusColor bool               `bson:"isCanCusColor,omitempty" json:"isCanCusColor"` //是否支持定义颜色
	Colors        []ArtworkColor     `bson:"colors,omitempty" json:"colors"`               //支持的颜色
	ShapeIds      []string           `bson:"shapeIds,omitempty" json:"shapeIds"`           //支持成型工艺
	CreateTime    time.Time          `bson:"createTime,omitempty" json:"createTime"`
	UpdateTime    time.Time          `bson:"updateTime,omitempty" json:"updateTime"`
}

type MatLib struct {
	Id         primitive.ObjectID `bson:"_id,omitempty" json:"_id"`
	Finishes   []FinishArtwork    `bson:"finishes,omitempty" json:"finishes"`
	ShapeIds   []string           `bson:"shapeIds,omitempty" json:"shapeIds"` //支持成型工艺
	Name       string             `bson:"name,omitempty" json:"name"`
	CusNum     string             `bson:"cusNum,omitempty" json:"cusNum"`
	Cover      string             `bson:"cover,omitempty" json:"cover"`
	Order      int32              `bson:"order,omitempty" json:"order"`
	DotQueen   string             `bson:"dotqueen,omitempty" json:"dotqueen"`
	Blend      string             `bson:"blend,omitempty" json:"blend"`
	Categories []string           `bson:"categories,omitempty" json:"categories"`
	CreateTime time.Time          `bson:"createTime,omitempty" json:"createTime"`
	UpdateTime time.Time          `bson:"updateTime,omitempty" json:"updateTime"`
}

type Shape struct {
	Id         primitive.ObjectID `bson:"_id,omitempty" json:"_id"`
	Name       string             `bson:"name,omitempty" json:"name"`
	Desc       string             `bson:"desc,omitempty" json:"desc"`
	CreateTime time.Time          `bson:"createTime,omitempty" json:"createTime"`
	UpdateTime time.Time          `bson:"updateTime,omitempty" json:"updateTime"`
}
